# encoding: utf-8
# generated by pybehave (do not edit)

import pybehave.core
import pybehave.result
from user_withdraws_cash_skels import *

class UserWithdrawsCash(pybehave.core.Story):
    def __init__(self):
        super(UserWithdrawsCash, self).__init__(
            pybehave.core.Narrative("Bank card holder", "to be able to withdraw cash from an ATM", "I don't have to visit the bank")
        )
    def specify(self):
        self.add_scenario(HappyScenario())
        self.add_scenario(HappyScenarioWithOverdraft())
        self.add_scenario(OverdrawnWithoutPermission())
        self.add_scenario(InLotsOfTrouble())

class HappyScenario(pybehave.core.Scenario):
    def __init__(self):
        super(HappyScenario, self).__init__()
    def specify(self):
        self.given(AccountIsInCredit())
        self.when(UserRequestsCash())
        self.then(AtmShouldDispenseCash())
        self.then(AtmShouldReturnBankCardToCustomer())
        self.then(AccountBalanceShouldBeReduced())

class HappyScenarioWithOverdraft(pybehave.core.Scenario):
    def __init__(self):
        super(HappyScenarioWithOverdraft, self).__init__()
    def specify(self):
        self.given(AccountHasOverdraftPermission())
        self.when(UserRequestsCash())
        self.then(AtmShouldDispenseCash())
        self.then(AtmShouldReturnBankCardToCustomer())
        self.then(AccountBalanceShouldBeReduced())

class OverdrawnWithoutPermission(pybehave.core.Scenario):
    def __init__(self):
        super(OverdrawnWithoutPermission, self).__init__()
    def specify(self):
        self.given(AccountHasNegativeBalanceWithoutPermission())
        self.when(UserRequestsCash())
        self.then(AtmShouldRefuseCash())
        self.then(AtmShouldReturnBankCardToCustomer())

class InLotsOfTrouble(pybehave.core.Scenario):
    def __init__(self):
        super(InLotsOfTrouble, self).__init__()
    def specify(self):
        self.given(AccountIsOverOverdraftLimit())
        self.when(UserRequestsCash())
        self.then(AtmShouldRefuseCash())
        self.then(AtmShouldReturnBankCardToCustomer())

def main(listeners):
    story = UserWithdrawsCash()
    story.listeners = listeners
    story.specify()
    story.run()

if __name__ == '__main__':
    main([pybehave.result.SimpleScenarioListener()])

#eof