# encoding: utf-8
# generated by pybehave (to be completed)

import pybehave.core

import atm

class AccountIsInCredit(pybehave.core.Given):
    def setup(self, world): 
        world['init_balance'] = 100
        world['account'] = atm.Account(100)

class AccountHasOverdraftPermission(pybehave.core.Given):
    def setup(self, world): 
        world['init_balance'] = 0
        world['account'] = atm.Account(0, 30)

class AccountHasNegativeBalanceWithoutPermission(pybehave.core.Given):
    def setup(self, world): 
        world['init_balance'] = 0
        world['account'] = atm.Account(0)

class AccountIsOverOverdraftLimit(pybehave.core.Given):
    def setup(self, world): 
        world['account'] = atm.Account(0, 10)

class UserRequestsCash(pybehave.core.Event):
    def occur_in(self, world): 
        account = world['account']
        account.debit(20)
        world['cash'] = 20

class AtmShouldDispenseCash(pybehave.core.Outcome):
    def verify(self, world):
        assert world['cash'] == 20, 'Cash not dispensed.'

class AtmShouldReturnBankCardToCustomer(pybehave.core.Outcome):
    def verify(self, world):
        pass

class AccountBalanceShouldBeReduced(pybehave.core.Outcome):
    def verify(self, world): 
        assert world['account'].balance == world['init_balance'] - 20, \
            'Balance not reduced.'

class AtmShouldRefuseCash(pybehave.core.Outcome):
    def verify(self, world): 
        world['cash'] = 0

#eof